require 'keybinding'
require 'physics'
require 'abilities'
require 'misc'
require 'load_n_save'
require 'Maps/mapmainmenu'
require 'Maps/map1'
require 'Maps/map2'
require 'Maps/map3'
require 'Maps/map4'
require 'Maps/map5'
require 'Maps/map6'
require 'Maps/map7'
require 'Maps/map8'
require 'Maps/map9'
require 'Maps/map10'
require 'Maps/map11'
require 'Maps/map12'
require 'Maps/map13'
require 'Maps/map14'
require 'Maps/map15'

function love.load()

	math.randomseed( os.time() )
	--key values
	TileSize = 24
	TilesetX, TilesetY = TileSize*8, TileSize*8
	SizeX, SizeY = 21, 21
	
	--on-screen offset of playing area
	OffsX, OffsY = 144,88
	
	--variables
	x,y,z,i,j,k = 0,0,1,0,0,0
	game_clock = 0
	
	--mouse stuff
	MouseX, MouseY, MouseTileX, MouseTileY = 0,0,1,1
	
	--remember!!!
	ExitTile = 12
	asd = 0	
	--game variables
	Minutes, Seconds = 0,0
	
	EditingMode = false
	Selected_Tile = 1
	EndingSequence = false
	
	Victoire = false
	LevelNumber = 0
	BeginningSequence_Y = -600
	VictorySequence	= 0

	--sounds
	menu = love.audio.newSource("menu.wav", "static")	
	laser = love.audio.newSource("laser.wav", "static")		
	--initializing font
	font = love.graphics.newFont("slkscre.ttf", 16)
	love.graphics.setFont(font)	
	
	--initializing 16-px tiles
	TilesetPic = love.graphics.newImage('TILESET_24.png')
	Tileset = { }
	
	for j=1, 8 do
		for i=1, 8 do 
			Tileset[((i-1)*8)+j] = love.graphics.newQuad((j-1)*TileSize, (i-1)*TileSize, TileSize, TileSize, TilesetX, TilesetY)
		end
	end	
	
	--initializing player sprites
	PlayerSprites = love.graphics.newImage('PLAYER.png')
	PlayerCharset = { }
	
	for i=1, 5 do 
		PlayerCharset[i] = love.graphics.newQuad((i-1)*24, 0, 24, 24, 120, 24)
	end	
	
	--initialiing autotiles
	AutoPic = love.graphics.newImage('AUTOTILE.png')
	Autoset = { }
	
	for j=1, 4 do
		for i=1, 4 do 
			Autoset[((i-1)*4)+j] = love.graphics.newQuad((j-1)*TileSize, (i-1)*TileSize, TileSize, TileSize, TileSize*4, TileSize*4)
		end
	end		
	
	--initializing pics
	Picset = {
	love.graphics.newImage('SKY1.png'),
	love.graphics.newImage('BORDER_LEFT.png'),	
	love.graphics.newImage('BORDER_RIGHT.png'),	
	love.graphics.newImage('BORDER_EMPTY.png'),	
	love.graphics.newImage('KATAMORI.png'),	
	love.graphics.newImage('TITLEPIC.png'),		
	}
	
	LoadMap()
	Loadmainmenu()

end

function love.draw()
	
	--GAME_CLOCK IS HERE, IT'S FUCKIN IMPORTANT!!!!
	game_clock = game_clock+1

	for j=1,SizeX do
		for i=1, SizeY do

			
			if (Victoire and SizeY-i>=VictorySequence) or not Victoire then
			--drawing field itself			
			love.graphics.draw(TilesetPic, Tileset[Field[j][i]], OffsX+(j-1)*TileSize, OffsY+(i-1)*TileSize)
			
			--drawing Laser table
			love.graphics.draw(TilesetPic, Tileset[Laser[j][i]], OffsX+(j-1)*TileSize, OffsY+(i-1)*TileSize)
			end

			--damagecounter for debugging
			--love.graphics.print(DamageCounter[j][i], OffsX+(j-1)*TileSize, OffsY+(i-1)*TileSize)
			
			--fixing Laser table if necessary
			if not Player.Grappling_Hook 									--if the hook ability is disabled
			or 
			(Player.Grappling_Hook 											-- OR enabled, but graphics appear below player
			and j == Player.TileX
			and i >= Player.TileY)
			then	
				if Laser[j][i] == 63 then Laser[j][i] = 64 end				--delete hook graphics 
			end
			
			if not Player.Laser_Activated 									--if the laser ability is disabled
			then
				if Laser[j][i] == 61 or Laser[j][i] == 62
				then Laser[j][i] = 64 end									--delete laser graphics
			end
			
			--behaviour and drawing related functions; I'd rather call them here than in update()
			Mirror_Behaviour(j,i)			--doing the mirror behaviour			
			Prism_Behaviour(j,i)			--doing the prism behaviour	
			Damaging(j,i,30)				--doing the laser damaging stuff
			Animating(j,i)					--animating certain textures
		end
	end	
	

	love.graphics.draw(Picset[1], 0,BeginningSequence_Y/4)			--sky
	
				if game_clock%20000 >300 and 
				Victoire and LevelNumber == 15  then
					love.graphics.print("Humans are coming.\n"
					.."They will not be happy if\n"
					.."they find me alive.\n"
					.."they should not leave\n"
					.."planet after visiting.\n"
					.."I can provide: they will not.\n\n\n"
					.."now I can fully talk, but some\n"
					.."time needs to get used to it again.\n"
					.."World rumbles, but do not worry.\n"
					.."I am going to defend you.\n\n"
					.."until the rest of existence.\n\n\n\n\n\n\n\n\n"
					.."I am Anubis.",OffsX+16,650-(VictorySequence*TileSize))			
				end	
	
	--main menu vs. ingame
	if LevelNumber == 0 then
	
	
		--HUD elements
		love.graphics.draw(Picset[4], 0,BeginningSequence_Y/4+88)		--middle border in main menu
		love.graphics.draw(Picset[4], 400,BeginningSequence_Y/4+88)
		love.graphics.draw(Picset[5], -10,2*BeginningSequence_Y+500)	--Katamori logo
		love.graphics.draw(Picset[6], 156,BeginningSequence_Y+104)		--titlepic	

		love.graphics.print("Katamori Entertainment Presents...",130,2*BeginningSequence_Y+600)	

		if BeginningSequence_Y == 0 then
		
	
			love.graphics.print("A robot, alone, lost, beneath the surface\n"
								.."of a forgotten homeworld. The only way\n"
								.."to look for help is to send the light of\n"
								.."the beacon up to the sky. But how?\n\n"
								.."press X to start the game",156,300)	
								
			love.graphics.print("This game was made from scratch within 48 hours  \n"
								.."during the 26-27th of april 2014 for Ludum Dare\n"
								.."game making event by Zoltan Schmidt 'Katamori'.",120,540)				
		else
			love.graphics.print("(esc to skip)",630,560)	
		end
	else
				Field[20][19] = 1		
				Field[ExitTile][1] = 2	

				--HUD elements
				love.graphics.draw(Picset[2], 0,88)			--left border
				love.graphics.draw(Picset[3], 648,88)		--right border
				
				--game progress "bar"
				for i=1, 3 do
					for j=1, 5 do
						if (3*(j-1))+ i <= LevelNumber then
							love.graphics.draw(TilesetPic, Tileset[58], i*(TileSize+12) - 20,270+j*(TileSize+12))	
						else
							love.graphics.draw(TilesetPic, Tileset[57], i*(TileSize+12) - 20,270+j*(TileSize+12))					
						end
					end
				end
				
				--textstuff
				if LevelNumber < 10 then 
					love.graphics.print("Beacon "..LevelNumber,13,150) 
				else 
					love.graphics.print("Beacon\n"..LevelNumber,13,150) 
				end	
				
				if CountColors(Field, 3) ~= 0 then love.graphics.draw(TilesetPic, Tileset[49], 675, 220) end
			
				if CountColors(Field, 9) + CountColors(Field, 10) + CountColors(Field, 11) + CountColors(Field, 12) ~= 0 
				then love.graphics.draw(TilesetPic, Tileset[50], 717, 220) end	
			
				if CountColors(Field, 13) + CountColors(Field, 14) + CountColors(Field, 15) + CountColors(Field, 16) ~= 0  
				then love.graphics.draw(TilesetPic, Tileset[51], 760, 220) end	
			
				if #Doors ~= 0 then love.graphics.draw(TilesetPic, Tileset[52], 675, 250) end	
				if #Portals ~= 0 then love.graphics.draw(TilesetPic, Tileset[53], 760, 250) end
			
			
				--showing used abilities
				if Player.Grappling_Hook then love.graphics.draw(TilesetPic, Tileset[59], 675, 150) end
				if Player.Laser_Activated then  love.graphics.draw(TilesetPic, Tileset[60], 760, 150) end	
			
				if EditingMode then love.graphics.draw(TilesetPic, Tileset[Selected_Tile], 760, 350) end
				
				--passed time:
				love.graphics.print(Minutes..":"..Seconds,30,255)
				
				--level text
				love.graphics.print(Texts(LevelNumber),675, 290)		
		--player drawing
		if SizeY-Player.TileY>=VictorySequence then
			love.graphics.draw(PlayerSprites, PlayerCharset[Player.Sprite], OffsX+(Player.TileX-1)*TileSize, OffsY+(Player.TileY-1)*TileSize)
		end
		
		--for the case of victory	
		if Victoire then
			for i=1, 4 do
				love.graphics.draw(TilesetPic, Tileset[62], OffsX + ((ExitTile-1)*TileSize), OffsY-(i*TileSize))
			end
			Laser[ExitTile][1] = 62
			Laser[ExitTile][2] = 62	
			
			if LevelNumber ~= 15 then
				if LevelNumber < 10 then 
					love.graphics.print("active!",20,170)
				else 
					love.graphics.print("Beacon\n"..LevelNumber.." active",13,150) 	
				end		
			end
			

		else
			--in any other cases	
			--showing obstacles


		end
	
	
	end	
	
				--autotiling
			Autotiling()
			
			
end

function love.update(dt)

	--editing mode 
	if love.mouse.isDown( "l"  ) and EditingMode then Field[MouseTileX][MouseTileY] = Selected_Tile end
	
	-- door + portal drawing and behaviour
	if not love.mouse.isDown( "l"  ) and not EditingMode then
		The_Doors()	
		Portal_Behav()
	end
						
	--beginning sequence	
	if BeginningSequence_Y ~= 0 then 
		BeginningSequence_Y = BeginningSequence_Y + 1
	else
		if asd == 0 then love.audio.play(menu) asd = asd+1 end
	end
		--victory sequence
	
	if Victoire and game_clock%10 == 0 
	then VictoryFoo() end

	--mouse constants
	MouseX, MouseY = love.mouse.getX(), love.mouse.getY()
	MouseTileX, MouseTileY = 1+math.floor((MouseX-OffsX)/TileSize), 1+math.floor((MouseY-OffsY)/TileSize)
	
	--timer
	--game_clock is iterated in love.draw!!!!!
	
	--actual clock
	if not Victoire then
		if game_clock%60 == 0 then Seconds = Seconds + 1 end	
		if Seconds == 60 then Minutes = Minutes + 1 Seconds = 0 end
	end
	
	if game_clock%10 == 0 then 
		--gravity script
		if not Player.Grappling_Hook then
			Gravity() 
		end
	end
	
	--player animation
	if game_clock%15 == 0 then 
		if Player.Laser_Activated then 
			if Player.Sprite == 1 or Player.Sprite == 5 then 
				Player.Sprite = 3
			elseif Player.Sprite == 3 or Player.Sprite == 4 then 
				Player.Sprite = Player.Sprite + 1
				

			end
		end
	end
	
			--sound effect
			if Player.Laser_Activated then 
			love.audio.play(laser)
				if not laser:isStopped()
				then
					if game_clock%45 ==0 then
						laser:rewind()	
					end
				end	
			end	
	

	--scripts and similar shit
	Grappling_Hook_Drawing()
	Laser_Beam_Drawing(Player.TileX, Player.TileY, Player.Laser_Dir)

	
	if Laser[ExitTile][3] == 62 then Victoire = true else Victoire = false end

end

function HasNeighbour(x,y, valueToCheck, Table)

	local itHas = false

	if Table[x-1][y] == valueToCheck then itHas = true
	elseif Table[x+1][y] == valueToCheck then itHas = true
	elseif Table[x][y-1] == valueToCheck then itHas = true
	elseif Table[x][y+1] == valueToCheck then itHas = true
	else itHas = false end
	
	return itHas
end

function CountColors(Table, valueToCheck)

	local asd=0
	for j=2,SizeX-1 do
		for i=2, SizeY-1 do
			if Table[j][i] == valueToCheck then asd=asd+1 end
		end
	end
	
	return asd
end
